/* Header for com.c */

typedef unsigned long dword;
typedef unsigned int word;
typedef unsigned char byte;
typedef unsigned char boolean;

#define COM1            0
#define COM2            1
#define COM3            2
#define COM4            3

#define BITS_8          0x03
#define BITS_7          0x02
#define STOP_1          0x00
#define STOP_2          0x04

#define EVEN_PARITY     0x18
#define ODD_PARITY      0x08
#define NO_PARITY       0x00

#define DTR             0x01
#define RTS             0x02
#define USER            0x04
#define LOOPBACK        0x10

#define D_CTS   0x0100
#define D_DSR   0x0200
#define D_RI            0x0400
#define D_DCD   0x0800
#define CTS             0x1000
#define DSR             0x2000
#define RI              0x4000
#define DCD             0x8000
#define PARITY  0x0004
#define THREMPTY        0x0020
#define BREAKDET        0x1000

#define dcdmask 0x80

#ifndef _COM_
extern
#endif
word port, flowflags, parity;

void dtr_out(byte flag);
void com_flow(byte flags);
void com_setspeed(word speed);                       /* set speed of comport */
word fos_getstatus(void);
int get_fos_info(void);
int fos_fillinbuf(void);
void com_putblock(byte *s, word len);
int fos_init(void);
void sys_init(void);         /* all system dependent init should be done here */
void sys_reset(void);                            /* same as above for de-init */
int com_outfull (void);          /* Return the amount in fossil output buffer */
int com_infull (void);          /* Return the amount in fossil input buffer */
int carrier(void);                                   /* Return carrier status */
void com_flush(void);              /* wait till all characters have been sent */
void com_putbyte (byte c);
void com_purge (void);
void com_dump (void);
int com_getbyte(void);
