/*
 * ======= USR modems line stats monitor ======
 *
 * (C) 1994 Maxim Volkonovsky (MaxWolf), FidoNet 2:5020/299
 * Compiled with Turbo C 2.0
 *
 */

#define VER			"0.03"
#define LOG_FILE	"smeter.log"

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <time.h>
#include <ctype.h>
#include "com.h"

byte cd_watch;

int wait_str(int n,char *s)
{
  int c; char *p;
	for (;;) {
		p = s;
		do {
			while ((c=com_getbyte()) == EOF)
				if (kbhit()) return 0;
				else if (cd_watch && !carrier()) return 0;
			if (!(n--)) return 0;
		} while	(c != *p);
		++p;
		do {
			if (!*p) return 1;
			while ((c=com_getbyte()) == EOF)
				if (kbhit()) return 0;
				else if (cd_watch && !carrier()) return 0;
		} while (c == *p++);
    }
}

void send_str(char *s)
{
	com_putblock(s, strlen(s));
}

/*
 * -----------
 */

#define S_SN	"S/N ratio (dB)         = "
#define S_SL	"Signal Level (dBm)     = "
#define S_AJ	"Amplitude Jitter (dB)  = "
#define S_PE	"Phase Error (??)       = "
#define S_GH	"Gain Hits              = "
#define S_TO	"Timing Offset (%/1000) = "
#define S_CO	"Carrier Offset (Hz)    = "


word aswap(word n)
{
	return (n<<12) | ((n&0xf0)<<4) | ((n&0xf00)>>4) | (n>>12);
}

#define	XOFFS	24
#define	XPOS	1
#define	YPOS	2

void show_pattern(void)
{
  int i;

	clrscr();
	gotoxy(XPOS + XOFFS + 4, YPOS - 1); cprintf("Snap");
	gotoxy(XPOS + XOFFS + 13, YPOS - 1); cprintf("Mean");
	i = YPOS;
	gotoxy(XPOS, i++);	cprintf(S_SN);
	gotoxy(XPOS, i++);	cprintf(S_SL);
	gotoxy(XPOS, i++);	cprintf(S_AJ);
	gotoxy(XPOS, i++);	cprintf(S_PE);
	gotoxy(XPOS, i++);	cprintf(S_GH);
	gotoxy(XPOS, i++);	cprintf(S_TO);
	gotoxy(XPOS, i++);	cprintf(S_CO);
}

/* size of overaging window */
#define	W_SIZE	30

word	s_qua,	s_qua_a[W_SIZE];	dword	s_qua_s;
int		s_lev,	s_lev_a[W_SIZE];	long	s_lev_s;
word	a_err,	a_err_a[W_SIZE];	dword	a_err_s;
word	p_err,	p_err_a[W_SIZE];	dword	p_err_s;
word	g_hits;
int		t_offs,	t_offs_a[W_SIZE];	long	t_offs_s;
int		c_offs,	c_offs_a[W_SIZE];	long	c_offs_s;

int		first_pass, w_ptr;

word _100log10(word a)   /* 100*log10(x) */
{
  int n, x, m, k, i;

	if (a == 0)
		return 0;

	for (i=0; a > 100; a /= 10, i++);

	n = 1;
	x = (int)((long)(1000) * ((int)a - 10)/((int)a + 10));
	k = (int)((long)x * x / 1000);
	m = x;

	while (x) { /* ln(x) */
		n += 2;
		x = (int)((long)x * k / 1000);
		m += x/n;
    }

	return m * 2 / 23 + (i+1) * 100;

}


void updateU(word v, word va[], dword *vs)
{
  int i;
	if (first_pass) {
		for (i = 0; i < W_SIZE; i++)
			va[i] = v;
		*vs = (dword)v * W_SIZE;
		w_ptr = 0;
	}
	*vs -= va[w_ptr];
	*vs += (va[w_ptr] = v);
}

void updateS(int v, int va[], long *vs)
{
  int i;
	if (first_pass) {
		for (i = 0; i < W_SIZE; i++)
			va[i] = v;
		*vs = (long)v * W_SIZE;
		w_ptr = 0;
	}
	*vs -= va[w_ptr];
	*vs += (va[w_ptr] = v);
}

void	show_stat(void)
{
  int i;

	directvideo = 1;
	i = YPOS;

	gotoxy(XPOS + XOFFS, i++);
	updateU(s_qua, s_qua_a, &s_qua_s);
	cprintf("%6u.%u %6u.%u", s_qua/10, s_qua%10,
			(word)(s_qua_s/W_SIZE)/10, (word)(s_qua_s/W_SIZE)%10);

	gotoxy(XPOS + XOFFS, i++);
	updateS(s_lev, s_lev_a, &s_lev_s);
	cprintf("%6d.%u %6d.%u", s_lev/10, abs(s_lev%10),
			(int)(s_lev_s/W_SIZE)/10, abs((int)(s_lev_s/W_SIZE)%10));

	gotoxy(XPOS + XOFFS, i++);
	updateU(a_err, a_err_a, &a_err_s);
	cprintf("%6u.%u %6u.%u", a_err/10, a_err%10,
			(word)(a_err_s/W_SIZE)/10, (word)(a_err_s/W_SIZE)%10);

	gotoxy(XPOS + XOFFS, i++);
	updateU(p_err, p_err_a, &p_err_s);
	cprintf("%8u   %6u", p_err, (word)(p_err_s/W_SIZE));

	gotoxy(XPOS + XOFFS, i++);
	cprintf("%8u", g_hits);

	gotoxy(XPOS + XOFFS, i++);
	updateS(t_offs, t_offs_a, &t_offs_s);
	cprintf("%6d.%u %6d.%u", t_offs/10, abs(t_offs%10),
			(int)(t_offs_s/W_SIZE)/10, abs((int)(t_offs_s/W_SIZE)%10));

	gotoxy(XPOS + XOFFS, i++);
	updateS(c_offs, c_offs_a, &c_offs_s);
	cprintf("%6d.%u %6d.%u", c_offs/10, abs(c_offs%10),
			(int)(c_offs_s/W_SIZE)/10, abs((int)(c_offs_s/W_SIZE)%10));

	first_pass = 0;
	w_ptr = w_ptr >= W_SIZE-1 ? 0 : ++w_ptr;

}

void store_stat(void)
{
  FILE *f;
  time_t t;
  #define STR_LEN 80
  char str[STR_LEN];

	gotoxy (XPOS, YPOS + 8);
	cprintf("Storing mean values in " LOG_FILE"... Enter comment>");
	str[0] = STR_LEN - 2; cgets(str);

	f = fopen(LOG_FILE, "a");
	if (!f) {
		gotoxy(XPOS, YPOS + 9);
		cprintf("Can\'t open file " LOG_FILE " ! press any key");
		getch();
		show_pattern();
		return;
	}

	time(&t);
	fprintf(f, "USR line stats log v" VER " (C) by MaxWolf at %s", ctime(&t));
	fprintf(f, "%s\n\n", str+2);
	fprintf(f, "%s %6u.%u\n", S_SN,
			(word)(s_qua_s/W_SIZE)/10, (word)(s_qua_s/W_SIZE)%10);
	fprintf(f, "%s %6d.%u\n", S_SL,
			(int)(s_lev_s/W_SIZE)/10, abs((int)(s_lev_s/W_SIZE)%10));
	fprintf(f, "%s %6u.%u\n", S_AJ,
			(word)(a_err_s/W_SIZE)/10, (word)(a_err_s/W_SIZE)%10);
	fprintf(f, "%s %8u\n", S_PE, (word)(p_err_s/W_SIZE));
	fprintf(f, "%s %8u\n", S_GH, g_hits);
	fprintf(f, "%s %6d.%u\n", S_TO,
			(int)(t_offs_s/W_SIZE)/10, abs((int)(t_offs_s/W_SIZE)%10));
	fprintf(f, "%s %6d.%u\n\n\n", S_CO,
			(int)(c_offs_s/W_SIZE)/10, abs((int)(c_offs_s/W_SIZE)%10));
	fclose(f);
	show_pattern();
}


word get_N(void)
{
  int c;
  word n;
	n =  0;
  	do {
		while ((c=com_getbyte()) == EOF)
			if (kbhit()) return 0;
		if (!isdigit(c))
			return n;
		n = n * 10 + (c - '0');
	} while	(1);
}

#define	GET_STAT_CMD	"aty7\r"

int monitor(void)
{
	if (!carrier())
		return 0;
	first_pass = 1;
	delay(1000);
	com_purge();
	send_str("+++");
	if (!wait_str(1000, "OK")) {
		fprintf(stderr, "\nCan't switch to command mode\n");
		return 1;
	}
	com_purge();
	send_str(GET_STAT_CMD);
	do {
		if (!wait_str(200, "Analog Stats")) {
rerr:
			if (kbhit())
				switch(getch()) {
					case 27:
						delay(1000);
						send_str("ato\r");
						delay(500);
						com_purge();
						puts("\n");
						return 0;
					case 13:
						store_stat();
						send_str(GET_STAT_CMD);
						continue;
					case 0:
						getch();
					default:
						goto para_continue;
				}
			if (carrier())
				fprintf(stderr, "\nError retrieving modem info\n");
			else
				fprintf(stderr, "\nCarrier has gone\n");
			return 1;
		}

		if (!wait_str(20, "Signal Quality = "))
			goto rerr;
		else
			s_qua = 500 - _100log10(get_N());

		if (!wait_str(20, "Signal Level = "))
			goto rerr;
		else
			s_lev = 20 - (int)(aswap(get_N())/125);

		if (!wait_str(20, "Amplitude Error = "))
			goto rerr;
		else
			a_err = get_N();

		if (!wait_str(20, "Phase Error = "))
			goto rerr;
		else
			p_err = get_N();

		if (!wait_str(20, "Gain Hits = "))
			goto rerr;
		else
			g_hits = get_N();

		if (!wait_str(20, "Timing Offset = "))
			goto rerr;
		else
			t_offs = (int)get_N() / 100;

		if (!wait_str(20, "Carrier Offset = "))
			goto rerr;
		else
			c_offs = (int)get_N() / 160;
para_continue:
		if (!wait_str(200, "OK\r\n"))
			goto rerr;

		if (!kbhit())
			send_str(GET_STAT_CMD);

		show_stat();

	} while (1);
}

int main(int argc, char **argv)
{
  FILE *f;
	f = fopen("matuta", "a");
	if (f) { fprintf(f, "mapipa\n");
	fclose(f); }
	fprintf(stderr, "USR modem's line stats monitor v" VER " (C) 1994 MaxWolf, 2:5020/299@fidonet.org\n");
	fprintf(stderr, "compiled " __DATE__ " "__TIME__"\n");
	port=1;	flowflags = RTS; parity = NO_PARITY;
	if (argc != 2) {
		fprintf(stderr, "usage: >smeter portN\n");
		fprintf(stderr, "hint: use <tab> to view, <enter> to log, <ctrl-q> to exit\n");
		exit(1);
	}
	port = atoi(argv[1]);

	sys_init();
	do {
	  int c;
		while (!kbhit()) if ( (c=com_getbyte()) != EOF) putch(c);
		if ( (c=getch()) == 'Q'-'@') {
			sys_reset();
			exit(0);
		} else if (c == 9) {
			show_pattern();
			cd_watch = 1;
			monitor();
			cd_watch = 0;
		} else
			com_putbyte(c);
	} while (1);
}
